## fpgatools 0.0+201212

=== Makefile ===
#
# Makefile - fpgatools
# Author: Wolfgang Spraul
#
# This is free and unencumbered software released into the public domain.
# For details see the UNLICENSE file at the root of the source tree.
#


CFLAGS  += -I$(CURDIR)/libs

LDFLAGS += -Wl,-rpath,$(CURDIR)/libs

OBJS 	= autotest.o bit2fp.o draw_svg_tiles.o fp2bit.o hstrrep.o \
	merge_seq.o new_fp.o pair2net.o sort_seq.o hello_world.o \
	blinking_led.o

DYNAMIC_LIBS = libs/libfpga-model.so libs/libfpga-bit.so \
	libs/libfpga-floorplan.so libs/libfpga-control.so \
	libs/libfpga-cores.so

.PHONY:	all test clean install uninstall FAKE
.SECONDARY:
.SECONDEXPANSION:

all: new_fp fp2bit bit2fp draw_svg_tiles autotest hstrrep \
	sort_seq merge_seq pair2net hello_world blinking_led

include Makefile.common

%.o:	%.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<
	$(MKDEP)

libs/%.so: FAKE
	@make -C libs $(notdir $@)

#
# Testing section - there are three types of tests:
#
# 1. design
#
# design tests run a design binary to produce floorplan stdout, which is
# converted to binary configuration and back to floorplan. The resulting
# floorplan after conversion through binary must match the original
# floorplan. Additionally, the original floorplan is compared to a gold
# standard if one exists.
#
# ./binary -> .fp -> .bit -> .fp -> compare first .fp to second and gold .fp
#
# 2. autotest
#
# autotest runs an automated test of some fpga logic and produces a log output
# which is compared against a gold standard.
#
# ./autotest -> stdout -> compare with gold standard
#
# 3. compare
#
# tool output is parsed to extract different types of model data and compare
# against a gold standard.
#
# tool output -> awk/processing -> compare to gold standard
#
# - extensions
#
# .ftest = fpgatools run test (design, autotest, compare)
#
# .f2gd = fpgatools to-gold diff
# .ffbd = diff between first fp and after roundtrip through binary config
# .fb2f = fpgatools binary config back to floorplan
# .ff2b = fpgatools floorplan to binary config
# .fco = fpgatools compare output for missing/extra
# .fcr = fpgatools compare missing/extra result
# .fcm = fpgatools compare match
# .fcd = fpgatools compare diff
# .fce = fpgatools compare extra
# .fao = fpgatools autotest output
# .far = fpgatools autotest result (diff to gold output)
#

test_dirs := $(shell mkdir -p test.gold test.out)

DESIGN_TESTS := hello_world blinking_led
AUTO_TESTS := logic_cfg routing_sw io_sw iob_cfg lut_encoding
COMPARE_TESTS := xc6slx9_tiles xc6slx9_devs xc6slx9_ports xc6slx9_conns xc6slx9_sw xc6slx9_swbits

DESIGN_GOLD := $(foreach target, $(DESIGN_TESTS), test.gold/design_$(target).fp)
AUTOTEST_GOLD := $(foreach target, $(AUTO_TESTS), test.gold/autotest_$(target).fao)
COMPARE_GOLD := $(foreach target, $(COMPARE_TESTS), test.gold/compare_$(target).fco)

test_gold: design_gold autotest_gold compare_gold
design_gold: $(DESIGN_GOLD)
autotest_gold: $(AUTOTEST_GOLD)
compare_gold: $(COMPARE_GOLD)

test: test_design test_auto test_compare
test_design: $(foreach target, $(DESIGN_TESTS), test.out/design_$(target).ftest)
test_auto: $(foreach target, $(AUTO_TESTS), test.out/autotest_$(target).ftest)
test_compare: $(foreach target, $(COMPARE_TESTS), test.out/compare_$(target).ftest)

# design testing targets

design_%.ftest: design_%.ffbd
	@if test -s $<; then echo "Design test: $(*F) - failed, diff follows"; cat $<; else echo "Design test: $(*F) - succeeded"; fi;
	@if test -s test.gold/$(basename $(@F)).fp; then diff -U 0 test.gold/$(basename $(@F)).fp $(basename $@).fp > $(basename $@).f2gd || (echo Diff to gold: && cat $(basename $@).f2gd); fi;

%.ffbd: %.fp %.fb2f
	@diff -u $(basename $@).fp $(basename $@).fb2f >$@ || true

%.fb2f: %.ff2b bit2fp
	@./bit2fp $< >$@ 2>&1

%.ff2b: %.fp fp2bit
	@./fp2bit $< $@

design_%.fp: $$*
	@./$(*F) >$@ 2>&1

# autotest targets

autotest_%.ftest: autotest_%.far
	@if test -s $<; then echo "Test failed: $(*F) (autotest), diff follows"; cat $<; else echo "Test succeeded: $(*F) (autotest)"; fi;

%.far: %.fao
	@if test ! -e test.gold/$(*F).fao; then echo Gold test.gold/$(*F).fao does not exist, aborting.; false; fi;
	@diff -U 0 -I "^O #NODIFF" test.gold/$(*F).fao $< >$@ || true

autotest_%.fao: autotest fp2bit bit2fp
	./autotest --test=$(*F) >$@ 2>&1

# compare testing targets

compare_%.ftest: compare_%.fcr
	@echo Test: $(*F) \(compare\)
	@cat $<|awk '{print " "$$0}'

%.fcr: %.fcm %.fcd %.fce
	@echo Matching lines - $*.fcm >$@
	@cat $*.fcm | wc -l >>$@
	@echo Missing lines - $*.fcd >>$@
	@cat $*.fcd | grep ^-[^-] | wc -l >>$@
	@if test -s $*.fce; then echo Extra lines - $*.fce: >>$@; cat $*.fce >>$@; fi;

%.fcm: %.fco
	@if test ! -e test.gold/$(*F).fco; then echo Gold test.gold/$(*F).fco does not exist, aborting.; false; fi;
	@comm -1 -2 $< test.gold/$(*F).fco >$@

%.fcd: %.fco
	@if test ! -e test.gold/$(*F).fco; then echo Gold test.gold/$(*F).fco does not exist, aborting.; false; fi;
	@diff -u test.gold/$(*F).fco $< >$@ || true

%.fce: %.fcd
	@cat $< | grep ^+[^+] >$@ || true

compare_%_tiles.fco: compare_%.fp
	@cat $<|awk '{if ($$1=="tile" && $$4=="name") printf "%s %s %s\n",$$2,$$3,$$5}'|sort >$@

compare_%_devs.fco: compare_%.fp
	@cat $<|awk '{if ($$1=="dev") {if ($$6=="type") printf "%s %s %s %s\n",$$2,$$3,$$4,$$7; else printf "%s %s %s\n",$$2,$$3,$$4; }}'|sort >$@

compare_%_ports.fco: compare_%.fp
	@cat $<|awk '{if ($$1=="port") printf "%s %s %s\n",$$2,$$3,$$4}'|sort >$@

compare_%_conns.fco: compare_%.fp sort_seq merge_seq
	@cat $<|awk '{if ($$1=="conn") printf "%s %s %s %s %s %s\n",$$2,$$3,$$5,$$6,$$4,$$7}'|sort|./sort_seq -|./merge_seq -|awk '{printf "%s %s %s %s %s %s\n",$$1,$$2,$$5,$$3,$$4,$$6}'|sort >$@

compare_%_sw.fco: compare_%.fp
	@cat $<|awk '{if ($$1=="sw") printf "%s %s %s %s %s\n",$$2,$$3,$$4,$$5,$$6}'|sort >$@

compare_%_swbits.fco: bit2fp
	@./bit2fp --printf-swbits | sort > $@

compare_%.fp: new_fp
	@./new_fp >$@

# todo: .cnets not integrated yet
%.cnets: %.fp pair2net
	cat $<|awk '{if ($$1=="conn") printf "%s-%s-%s %s-%s-%s\n",$$2,$$3,$$4,$$5,$$6,$$7}' |./pair2net -|sort >$@
	@echo Number of conn nets:
	@cat $@|wc -l
	@echo Number of connection points:
	@cat $@|wc -w
	@echo Largest net:
	@cat $@|awk '{if (NF>max) max=NF} END {print max}'

#
# end of testing section
#

autotest: autotest.o $(DYNAMIC_LIBS)

hello_world: hello_world.o $(DYNAMIC_LIBS)

blinking_led: blinking_led.o $(DYNAMIC_LIBS)

fp2bit: fp2bit.o $(DYNAMIC_LIBS)

bit2fp: bit2fp.o $(DYNAMIC_LIBS)

new_fp: new_fp.o $(DYNAMIC_LIBS)

draw_svg_tiles: CFLAGS += `pkg-config libxml-2.0 --cflags`
draw_svg_tiles: LDLIBS += `pkg-config libxml-2.0 --libs`
draw_svg_tiles: draw_svg_tiles.o $(DYNAMIC_LIBS)

pair2net: pair2net.o $(DYNAMIC_LIBS)

sort_seq: sort_seq.o $(DYNAMIC_LIBS)

merge_seq: merge_seq.o $(DYNAMIC_LIBS)

hstrrep: hstrrep.o $(DYNAMIC_LIBS)

xc6slx9.fp: new_fp
	./new_fp > $@

xc6slx9.svg: draw_svg_tiles
	./draw_svg_tiles | xmllint --pretty 1 - > $@

clean:
	@make -C libs clean
	rm -f $(OBJS) *.d
	rm -f 	draw_svg_tiles new_fp hstrrep sort_seq merge_seq autotest
	rm -f	fp2bit bit2fp pair2net hello_world blinking_led
	rm -f	xc6slx9.fp xc6slx9.svg
	rm -f	$(DESIGN_GOLD) $(AUTOTEST_GOLD) $(COMPARE_GOLD)
	rm -f	test.gold/compare_xc6slx9.fp
	rm -f	$(foreach f, $(DESIGN_TESTS), test.out/design_$(f).ffbd)
	rm -f	$(foreach f, $(DESIGN_TESTS), test.out/design_$(f).ff2b)
	rm -f	$(foreach f, $(DESIGN_TESTS), test.out/design_$(f).fb2f)
	rm -f	$(foreach f, $(DESIGN_TESTS), test.out/design_$(f).f2gd)
	rm -f	$(foreach f, $(DESIGN_TESTS), test.out/design_$(f).fp)
	rm -f	test.out/autotest_*
	rm -f	$(foreach f, $(COMPARE_TESTS), test.out/compare_$(f).fco)
	rm -f	$(foreach f, $(COMPARE_TESTS), test.out/compare_$(f).fcr)
	rm -f	$(foreach f, $(COMPARE_TESTS), test.out/compare_$(f).fcm)
	rm -f	$(foreach f, $(COMPARE_TESTS), test.out/compare_$(f).fcd)
	rm -f	$(foreach f, $(COMPARE_TESTS), test.out/compare_$(f).fce)
	rm -f	test.out/compare_xc6slx9.fp
	rmdir --ignore-fail-on-non-empty test.out test.gold

install: fp2bit bit2fp
	@make -C libs install
	mkdir -p $(DESTDIR)/$(PREFIX)/bin/
	install -m 755 fp2bit $(DESTDIR)/$(PREFIX)/bin/
	install -m 755 bit2fp $(DESTDIR)/$(PREFIX)/bin/
	chrpath -d $(DESTDIR)/$(PREFIX)/bin/fp2bit
	chrpath -d $(DESTDIR)/$(PREFIX)/bin/bit2fp

uninstall:
	@make -C libs uninstall
	rm -f $(DESTDIR)/$(PREFIX)/bin/{fp2bit,bit2fp}

=== libs/Makefile ===
#
# Makefile - fpgatools
# Author: Wolfgang Spraul
#
# This is free and unencumbered software released into the public domain.
# For details see the UNLICENSE file at the root of the source tree.
#

LIBS_VERSION_MAJOR = 0
LIBS_VERSION = $(LIBS_VERSION_MAJOR).0.0

LIBFPGA_BIT_OBJS       = bit_frames.o bit_regs.o
LIBFPGA_MODEL_OBJS     = model_main.o model_tiles.o model_devices.o \
	model_ports.o model_conns.o model_switches.o model_helper.o
LIBFPGA_FLOORPLAN_OBJS = floorplan.o
LIBFPGA_CONTROL_OBJS   = control.o
LIBFPGA_CORES_OBJS     = parts.o helper.o

OBJS := $(LIBFPGA_CORES_OBJS) $(LIBFPGA_BIT_OBJS) $(LIBFPGA_MODEL_OBJS) \
	$(LIBFPGA_FLOORPLAN_OBJS) $(LIBFPGA_CONTROL_OBJS)

DYNAMIC_LIBS = libfpga-model.so libfpga-bit.so libfpga-floorplan.so \
	libfpga-control.so libfpga-cores.so

DYNAMIC_HEADS = bit.h control.h floorplan.h helper.h model.h parts.h

SHARED_FLAGS = -shared -Wl,-soname,$@.$(LIBS_VERSION_MAJOR)
.PHONY:	all clean install uninstall FAKE

all: $(DYNAMIC_LIBS) $(DYNAMIC_LIBS:.so=.a)

include ../Makefile.common

libfpga-cores.a: $(LIBFPGA_CORES_OBJS)

libfpga-bit.a: $(LIBFPGA_BIT_OBJS)

libfpga-model.a: $(LIBFPGA_MODEL_OBJS)

libfpga-floorplan.a: $(LIBFPGA_FLOORPLAN_OBJS)

libfpga-control.a: $(LIBFPGA_CONTROL_OBJS)

%.a:
	$(AR) $@ $^
	$(RANLIB) $@

libfpga-cores.so: $(LIBFPGA_CORES_OBJS)

libfpga-bit.so: $(LIBFPGA_BIT_OBJS)

libfpga-model.so: $(LIBFPGA_MODEL_OBJS)

libfpga-floorplan.so: $(LIBFPGA_FLOORPLAN_OBJS)

libfpga-control.so: $(LIBFPGA_CONTROL_OBJS)

%.so:
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@.$(LIBS_VERSION) $^
	@ln -sf $@.$(LIBS_VERSION_MAJOR) $@
	@ln -sf $@.$(LIBS_VERSION) $@.$(LIBS_VERSION_MAJOR)

%.o:	%.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -fPIC -o $@ -c $<
	$(MKDEP)

clean:
	rm -f $(OBJS) $(OBJS:.o=.d) $(DYNAMIC_LIBS)
	rm -f $(DYNAMIC_LIBS:.so=.a)
	rm -f $(DYNAMIC_LIBS:.so=.so.$(LIBS_VERSION_MAJOR))
	rm -f $(DYNAMIC_LIBS:.so=.so.$(LIBS_VERSION))

install: all
	mkdir -p $(DESTDIR)/$(PREFIX)/include/
	mkdir -p $(DESTDIR)/$(PREFIX)/lib/
	install -m 644 $(DYNAMIC_HEADS) $(DESTDIR)/$(PREFIX)/include/
	for f in $(DYNAMIC_LIBS); do \
	  chrpath -d $$f.$(LIBS_VERSION_MAJOR) && \
	  install -m 644 $$f.$(LIBS_VERSION) $(DESTDIR)/$(PREFIX)/lib/$$f.$(LIBS_VERSION) && \
	  (cd $(DESTDIR)/$(PREFIX)/lib/ && \
	   ln -sf $$f.$(LIBS_VERSION) $$f.$(LIBS_VERSION_MAJOR) && \
	   ln -sf $$f.$(LIBS_VERSION_MAJOR) $$f) \
	  || exit 1; done
	for f in $(DYNAMIC_LIBS:.so=.a); do \
	  install -m 644 $$f $(DESTDIR)/$(PREFIX)/lib/$$f \
	  || exit 1; done

uninstall:
	for f in $(DYNAMIC_HEADS); do rm -f $(DESTDIR)/$(PREFIX)/include/$$f || exit 1; done
	for f in $(DYNAMIC_LIBS) $(DYNAMIC_LIBS:.so=.a) \
	  $(DYNAMIC_LIBS:.so=.so.$(LIBS_VERSION_MAJOR)) \
	  $(DYNAMIC_LIBS:.so=.so.$(LIBS_VERSION)); do \
	  rm -f $(DESTDIR)/$(PREFIX)/lib/$$f || exit 1; done

=== mini-jtag/Makefile ===
#
# Author: Xiangfu Liu
#
# This is free and unencumbered software released into the public domain.
# For details see the UNLICENSE file at the root of the source tree.
#

LDLIBS += `pkg-config libftdi --libs`
OBJS := mini-jtag.o load-bits.o jtag.o

.PHONY:	all clean
.PHONY:	install uninstall
.PHONY:	test test-counter test-blinking test-hello_world

all: mini-jtag

include ../Makefile.common

mini-jtag: $(OBJS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LDLIBS)

%.o:	%.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<
	$(MKDEP)

install: all
	mkdir -p $(DESTDIR)/$(PREFIX)/bin/
	install -m 755 mini-jtag $(DESTDIR)/$(PREFIX)/bin/

uninstall:
	rm -f $(DESTDIR)/$(PREFIX)/bin/mini-jtag

clean:
	rm -f $(OBJS)
	rm -f $(OBJS:.o=.d)
	rm -f mini-jtag

%.bit:
	@echo ""
	@echo "Move the config bits file: <$@> here."
	@echo ""
	@exit 1

test: test-hello_world test-blinking test-counter

hello_world.bit:
	make -C .. hello_world fp2bit
	../hello_world | ../fp2bit - $@

test-hello_world: hello_world.bit mini-jtag
	./mini-jtag load $<
	sleep 2

blinking.bit:
	make -C .. blinking_led fp2bit
	../blinking_led | ../fp2bit - $@

test-blinking: blinking.bit mini-jtag
	./mini-jtag load $<
	sleep 2

test-counter: counter.bit mini-jtag
	@./mini-jtag load $<
	@echo "Read counter registers (1 ~ 5)"
	@./mini-jtag read 0		# read version
	@./mini-jtag read 1		# read counter EN
	@./mini-jtag read 2		# read counter WE
	@./mini-jtag read 3		# read counter_set
	@./mini-jtag read 4		# read counter
	@echo "Read counter"
	@./mini-jtag write 1 1		# enable counter
	@./mini-jtag read 4		# read counter
	@./mini-jtag write 1 0		# disable counter
	@echo "Set counter to 50000000"
	@./mini-jtag write 2 1		# set counter WE
	@./mini-jtag write 3 50000000	# set counter
	@./mini-jtag read 3		# read counter_set
	@./mini-jtag write 2 0		# set counter WE
	@echo "Read counter"
	@./mini-jtag write 1 1		# enable counter
	@./mini-jtag read 4		# read counter
	@echo "Sleep 1 second for count"
	@sleep 1
	@./mini-jtag read 4		# read counter
	@./mini-jtag write 1 0		# disable counter

=== debian/changelog ===
fpgatools (0.0+201212-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061945

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 09:08:25 +0000

fpgatools (0.0+201212-1) unstable; urgency=low

  * New snapshot, taken from commit f4b5b89
  * Initial release. (Closes: #686949)

 -- Xiangfu Liu <xiangfu@openmobilefree.net>  Tue, 14 Aug 2012 10:03:41 +0800

=== debian/control ===
Source: fpgatools
Section: electronics
Priority: extra
Maintainer: Xiangfu Liu <xiangfu@openmobilefree.net>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 9), dpkg-dev (>= 1.16.1~),
 bash (>= 4), chrpath (>= 0.13)
Standards-Version: 3.9.4
DM-Upload-Allowed: yes
Homepage: https://github.com/Wolfgang-Spraul/fpgatools
Vcs-Git: git://github.com/Wolfgang-Spraul/fpgatools.git
Vcs-Browser: https://github.com/Wolfgang-Spraul/fpgatools

Package: libfpga0t64
Provides: ${t64:Provides}
Replaces: libfpga0
Breaks: libfpga0 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libraries of fpgatools
 fpgatools is a toolchain to program field-programmable gate arrays
 (FPGA).  The only supported chip at this time is the xc6slx9, a cheap
 but powerful 45nm-generation chip with about 2400 LUTs, block ram and
 multiply-accumulate devices.
 .
 This package provides a shared library for small independent
 command line utilities contributing to the fpgatools.
  * plain C, no C++
  * simple Makefiles
  * text-based file formats
  * automatic test suite

Package: libfpga-dev
Architecture: any
Section: libdevel
Depends: libfpga0t64 (= ${binary:Version}), ${misc:Depends}
Description: development files for fpgatools
 fpgatools is a toolchain to program field-programmable gate arrays
 (FPGA).  The only supported chip at this time is the xc6slx9, a cheap
 but powerful 45nm-generation chip with about 2400 LUTs, block ram and
 multiply-accumulate devices.
 .
 This package contains headers and libraries for developing bits file 
 that makes use of libfpga.

Package: fpgatools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfpga0t64 (= ${binary:Version})
Description: tool to program field-programmable gate arrays
 fpgatools is a toolchain to program field-programmable gate array
 (FPGA).  The only supported chip at this time is the xc6slx9, a cheap
 but powerful 45nm-generation chip with about 2400 LUTs, block ram and
 multiply-accumulate devices.

=== debian/rules ===
#!/usr/bin/make -f
# This file is in the public domain.
# You may freely use, modify, distribute, and relicense it.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PREFIX=/usr

%:
	dh $@

override_dh_auto_build:
	$(MAKE) fp2bit bit2fp

override_dh_auto_clean:
	$(MAKE) clean
	sh debian/clean.sh

override_dh_installchangelogs:
	dpkg-parsechangelog --format rfc822 --all | \
		awk -f debian/changelog.upstream.awk
	dh_installchangelogs debian/changelog.upstream

# Remove auto test for fast develop
# will include auto_test in the end
override_dh_auto_test:

REPO = git://github.com/Wolfgang-Spraul/fpgatools.git
BRANCH = master
get-orig-source:
	REPO='$(REPO)' BRANCH='$(BRANCH)' \
		sh ./debian/get-orig-source.sh
